window.$ = function(selector, root) {
	if (root === undefined) root = window.document;
	return root.querySelector(selector);
};
window.$$ = function(selector, root) {
	if (root === undefined) root = window.document;
	return root.querySelectorAll(selector);
};

/*
	method
	url
	callback
	data
	token
*/
window.XmlHttp = function(args) {
	var xmlhttp = (function() {
		var xmlhttp;
		try {
			xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
			  xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (E) {
			  xmlhttp = false;
			}
		}
		if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
			xmlhttp = new XMLHttpRequest();
		}
		return xmlhttp;
	})();

	var str = "";
	for (var key in args.data) {
		if (str != "") str += "&";
		str += key + "=" + encodeURIComponent(args.data[key]);
	}

	/*
	Странность работы XmlHttpRequest: При создании запроса GET и последующй отправке данных через .send()
	данные не передаются, поэтому запрос надо писать непосредственно в URL: /product?category=something
	*/

	xmlhttp.open(args.method, ApiBaseURL + args.url + ((args.method == 'GET') ? ('?' + str) : ''), true);

	xmlhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	if (window.Token) {
		xmlhttp.setRequestHeader('x-access-token', window.Token);
	}
	xmlhttp.onreadystatechange = function() {
		if (xmlhttp.readyState == 4) {
			args.callback(JSON.parse(xmlhttp.responseText));
		}
	};

	xmlhttp.send(str);
};

window.Message = (function(selector) {
	var obj = {}, root;

	obj.show = function(message, title, type) {
		if (!root) root = $(selector);

		if (!type)
			type = 'default';
		else if (type == 'error') 
			type = 'danger';


		root.setAttribute('class', 'panel panel-' + type);
		root.style.display = 'block';
		$('#message-text', root).innerHTML = message;
		
		$('#message-title', root).innerHTML = title;
		$('#message-title', root).style.display = title ? 'block' : 'none';			$('#message-title', root)
	}
	obj.hide = function() {
		if (!root) root = $(selector);
		root.style.display = 'none';
	}

	return obj;
})(MessageSelector);



/*
██████╗  █████╗  ██████╗ ███████╗███████╗
██╔══██╗██╔══██╗██╔════╝ ██╔════╝██╔════╝
██████╔╝███████║██║  ███╗█████╗  ███████╗
██╔═══╝ ██╔══██║██║   ██║██╔══╝  ╚════██║
██║     ██║  ██║╚██████╔╝███████╗███████║
╚═╝     ╚═╝  ╚═╝ ╚═════╝ ╚══════╝╚══════╝
*/
function URLToArray(url) {
    var request = {};
    var pairs = url.substring(url.indexOf('?') + 1).split('&');
    for (var i = 0; i < pairs.length; i++) {
        if(!pairs[i])
            continue;
        var pair = pairs[i].split('=');
        request[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1]);
     }
     return request;
}

window.Pages = {
	"index": function() {
		if (!Token)
			return Templator.use("index_unauth");
		else {
			XmlHttp({
				'method': 'GET',
				'url': 'category',
				'data': {},
				'callback': function(resp) {
					var html = '';

					for(var i = 0; i < resp.length; i++) {
						html += Templator.use('cat_list_item', resp[i]);
					}

					$('main').innerHTML = Templator.use('index_auth', { 'items': html });
				}
			});
			return Templator.use("loader");
		}
	},
	"register": function() {
		return Templator.use("register");
	},
	"login": function() {
		return Templator.use("login");
	},
	"logout": function() {
		localStorage.TOKEN = '';
		window.CurrentRedirect = setTimeout(function() {
			window.location.hash = '#index';
		}, 2000);
		Message.show('Выход произведён. Перенаправление на главную...');
		return Templator.use("loader");
	},
	"cat": function(action, id) {
		if (!Token)
			return Templator.use("unauth")

		var pid = parseInt(id);
		
		if (action == 'add') {
			return Templator.use("cat_add");
		}
		else if (action == 'delete') {
			TriggerAction('cat_delete', 'object', { 'id': id });
		}
		else if (action == 'edit') {
			XmlHttp({
				'method': 'GET',
				'url': 'category/' + id,
				'data': { 'id': id },
				'callback': function(resp) {
					if (resp.name) {
						$('main').innerHTML = Templator.use('cat_' + action, resp);
					}
					else {
						Message.show('Категории не существует');
						return '';
					}
				}
			});
		}

		return '';
	},

	"products": function() {
		if (!Token)
			return Templator.use("unauth")

		data = URLToArray(Array.prototype.join.call(arguments, '_'));

		XmlHttp({
			'method': 'GET',
			'url': 'product',
			'data': data,
			'callback': function(resp) {
				var html = '';

				for(var i = 0; i < resp.length; i++) {
					html += Templator.use('products_item', resp[i]);
				}

				XmlHttp({
					'method': 'GET',
					'url': 'category',
					'data': {},
					'callback': function(resp2) {
						var html2 = '';

						for(var i = 0; i < resp2.length; i++) {
							html2 += Templator.use('product_add_option', resp2[i]);
						}

						$('main').innerHTML = Templator.use('products', { 
							'items': html || 'Товары не найдены', 
							'cats': html2,
							'search': data,
						});
						if (data.category)
							$('main select[name="category"] option[value="' + data.category + '"]')
								.selected = true;
					}
				});
			}
		});

		return '';
	},

	"product": function(action, id) {
		if (!Token)
			return Templator.use("unauth")

		var pid = parseInt(id);

		if (action == 'add') {
			XmlHttp({
				'method': 'GET',
				'url': 'category',
				'data': {},
				'callback': function(resp) {
					var html = '';

					for(var i = 0; i < resp.length; i++) {
						html += Templator.use('product_add_option', resp[i]);
					}

					$('main').innerHTML = Templator.use('product_add', { 'cats': html });
				}
			});

			return '';
		}
		else if (action == 'delete') {
			TriggerAction('product_delete', 'object', { 'id': id });
		}
		else if (action == 'edit') {
			XmlHttp({
				'method': 'GET',
				'url': 'product/' + id,
				'data': { 'id': id },
				'callback': function(resp) {
					if (resp.name) {
						var product = resp;
						XmlHttp({
							'method': 'GET',
							'url': 'category',
							'data': {},
							'callback': function(resp) {
								var html = '';

								for(var i = 0; i < resp.length; i++) {
									html += Templator.use('product_add_option', resp[i]);
								}

								product.cats = html;
								$('main').innerHTML = Templator.use('product_edit', product);

								$('main select[name="category"] option[value="' + product.category._id + '"]')
									.selected = true;
							}
						});
					}
					else {
						Message.show('Товара не существует');
						return '';
					}
				}
			});
		}
		else if (action == 'view') { 
			XmlHttp({
				'method': 'GET',
				'url': 'product/' + id,
				'data': { 'id': id },
				'callback': function(resp) {
					if (resp.name) {
						var product = resp;

						$('main').innerHTML = Templator.use('product_view', product);
					}
					else {
						Message.show('Товара не существует');
						return '';
					}
				}
			});
		}

		return '';
	}

};

window.SetPageStopper = false;
window.SetPage = function(hash, data) {
	if (SetPageStopper) return;
	SetPageStopper = true;

	if (window.CurrentRedirect) clearTimeout(window.CurrentRedirect);
	Message.hide();
	
	if (hash == "") hash = "#index";
	window.location.hash = hash;

	CheckAuth();

	var parts = hash.substr(1).split('_');
		page = parts[0];
		pars = data ? data : parts.slice(1);

	var html = Pages[page].apply(null, pars),
		main = $('main');

	if (html) {
		main.innerHTML = html;
		main.id = page;
	}
	SetPageStopper = false;
};

window.CheckAuth = function() {
	var html = '';
	if (localStorage.TOKEN && localStorage.TOKEN_CREATED &&
		((new Date()).getTime() - localStorage.TOKEN_CREATED < TokenLifeTime)) {
		window.UserName = localStorage.USERNAME;
		window.Token = localStorage.TOKEN;

		html = Templator.use('header_auth', { 'name' : window.UserName });
	}
	else {
		window.Auth = false;
		window.Token = false;
		html = Templator.use('header_not_auth');
	}

	$('#authCheckRoot').innerHTML = html;
}

window.onhashchange = function () {
	window.SetPage(window.location.hash);
}

window.PerformSearch = function(form) {
	var data = {},
		elems = $$('[name]', form);
	for (let i = 0; i < elems.length; i++) {
		let elem = elems[i];
		if ((elem.value != '') && (elem.value != 0))
			data[elem.name] = elem.value;
	}

	var pairs = [];
	for (var key in data)
		if (data.hasOwnProperty(key))
			pairs.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
	
	SetPage('#products_' + pairs.join('&'));
}
/*
 █████╗  ██████╗████████╗██╗ ██████╗ ███╗   ██╗███████╗
██╔══██╗██╔════╝╚══██╔══╝██║██╔═══██╗████╗  ██║██╔════╝
███████║██║        ██║   ██║██║   ██║██╔██╗ ██║███████╗
██╔══██║██║        ██║   ██║██║   ██║██║╚██╗██║╚════██║
██║  ██║╚██████╗   ██║   ██║╚██████╔╝██║ ╚████║███████║
╚═╝  ╚═╝ ╚═════╝   ╚═╝   ╚═╝ ╚═════╝ ╚═╝  ╚═══╝╚══════╝
*/

window.Actions = {
	'register': {
		'method': 'POST',
		'url': 'auth/register',
		'condition': function(resp) {
			return resp.success;
		},
		'onsuccess': function(resp) {
			localStorage.TOKEN = resp.token;
			localStorage.TOKEN_CREATED = (new Date()).getTime();

			SetPage('#index');
		},
		'onerror': function(resp) {
			Message.show(resp.error.validationError ? 
				resp.error.validationError.login : resp.error, 
				'Ошибка входа', 'error');
		}
	},
	'login': {
		'method': 'POST',
		'url': 'auth',
		'condition': function(resp) {
			return resp.success;
		},
		'onsuccess': function(resp) {
			localStorage.TOKEN = resp.token;
			localStorage.TOKEN_CREATED = (new Date()).getTime();

			SetPage('#index');
		},
		'onerror': function(resp) {
			Message.show(resp.error.validationError ? 
				resp.error.validationError.login : resp.error, 
				'Ошибка входа', 'error');
		}
	},
	'cat_add': {
		'method': 'POST',
		'url': 'category',
		'condition': function(resp) {
			return resp.name;
		},
		'onsuccess': function(resp) {
			SetPage('#cat_view_' + resp._id);
		},
		'onerror': function(resp) {
			Message.show(resp.error, 'Добавление категории', 'error');
		}
	},
	'cat_edit': {
		'method': 'PUT',
		'url': 'category/:id',
		'condition': function(resp) {
			return resp.success;
		},
		'onsuccess': function(resp) {
			SetPage('#cat_list');
		},
		'onerror': function(resp) {
			Message.show(resp.error, 'Добавление категории', 'error');
		}
	},
	'cat_delete': {
		'method': 'DELETE',
		'url': 'category/:id',
		'condition': function(resp) {
			return resp.success;
		},
		'onsuccess': function(resp) {
			SetPage('#cat');
			Message.show('Категория удалена успешно', 'Удаление категории', 'success');
		},
		'onerror': function(resp) {
			Message.show(resp.error, 'Удаление категории', 'error');
		}
	},
	
	'product_add': {
		'method': 'POST',
		'url': 'product',
		'condition': function(resp) {
			return resp.name;
		},
		'onsuccess': function(resp) {
			SetPage('#product_view_' + resp._id);
		},
		'onerror': function(resp) {
			Message.show(resp.error, 'Добавление товара', 'error');
		}
	},
	'product_edit': {
		'method': 'PUT',
		'url': 'product/:id',
		'condition': function(resp) {
			return resp.success;
		},
		'onsuccess': function(resp) {
			SetPage('#products');
		},
		'onerror': function(resp) {
			Message.show(resp.error, 'Добавление категории', 'error');
		}
	},
	'product_delete': {
		'method': 'DELETE',
		'url': 'product/:id',
		'condition': function(resp) {
			return resp.success;
		},
		'onsuccess': function(resp) {
			SetPage('#products');
			Message.show('Товар удалён успешно', 'Удаление товара', 'success');
		},
		'onerror': function(resp) {
			Message.show(resp.error, 'Удаление товара', 'error');
		}
	},
};

window.TriggerAction = function(id, type, rules) {
	var data = {};

	if (type == 'form') {
		var elems = $$('[name]', rules.target);
		for (let i = 0; i < elems.length; i++) {
			let elem = elems[i];
			data[elem.name] = elem.value;
		}
	}
	else if (type == 'object') {
		data = rules;
	}

	var action = Actions[id];

	if ((action == 'register') || (action == 'login')) {
		localStorage.USERNAME = data.login;
	}

	XmlHttp({
		'method': action.method,
		'url': action.url.replace(':id', data.id),
		'data': data,
		'callback': function(resp) {
			if (action.condition(resp))
				action.onsuccess(resp);

			else 
				action.onerror(resp);
		}
	});
}

/*
██╗███╗   ██╗██╗████████╗
██║████╗  ██║██║╚══██╔══╝
██║██╔██╗ ██║██║   ██║   
██║██║╚██╗██║██║   ██║   
██║██║ ╚████║██║   ██║   
╚═╝╚═╝  ╚═══╝╚═╝   ╚═╝   
*/
window.Init = function() {
	SetPage(document.location.hash);
}

